#include "hre.h"
#include "lexical.h"
#include <stdio.h>
#include "debug.h"

/*     lexical code   ̸ Ѵ.  */
#define DEF_LEXICAL(SYM, NAME) NAME,
const char lexical_name[MAX_LEXICAL_CODES] = {
#include "lexical.def"
};
#undef DEF_LEXICAL

/* Ʒ  ڴ EXP_TAG  enumerator  1  1 ϴ   Ͱ
     Ѵ.     ʿϴ.  */
#define DEF_EXP_TAG(SYM, STR) STR,
const char *exp_tag_name[MAX_EXP_TAG] = {
#include "exp_tag.def"
};
#undef DEF_EXP_TAG

/* ޸  */
struct memory m_stat = { 
  0, 
  0
};

/* SP  Ǿ ִ  `µ'   Ѵ.  */
void
debug_state (p, sp)
     struct hre_tree *p;
     struct state * sp;
{
  int j=0;
  int i=0;
  
  printf ("-------+-------+-------+-------+-------+-------+------\n");
  printf ("Ŭ |   |*SList |Accept |Shift  |Sh.lhs |Sh.rhs\n");
  printf ("-------+-------+-------+-------+-------+-------+------\n");
 BEGIN:
  if (STATE_CLASS_P (sp) > 100 || STATE_S_LIST_SIZE_P (sp) > 100)
    goto END;
  printf ("%6d | %5d | ", STATE_CLASS_P (sp), STATE_S_LIST_SIZE_P (sp));
  while (j<2)
    {
      if (STATE_S_LIST_P_N (sp, j) < 100 && STATE_S_LIST_P_N (sp, j) > 0)
        printf ("%2d ", STATE_S_LIST_P_N (sp, j));
      else
        printf (" 0 ");
      j++;
    }
  j = 0;  
  printf ("| %5d | %5d | ", STATE_ACCEPT (sp), STATE_SHIFTS (sp));
  while (i < STATE_SHIFTS (sp))
    {
      if (STATE_SH_LIST_N_LHS (sp, i) == NULL)
        printf ("NU ");
      else
	{
	  int s = ((int) SYM_NAME (STATE_SH_LIST_N_LHS (sp, i))[0]) & 0xff;

	  if (s > 0x7f)
	    printf ("0x%x ", s);
	  else
	    printf ("%2s ", SYM_NAME (STATE_SH_LIST_N_LHS (sp, i)));
	}
      i++;
    }
  i=0;
  if (STATE_SHIFTS (sp) == 0)
    printf ("      | ");
  else if (STATE_SHIFTS (sp) == 1)
    printf ("   | ");
  else 
    printf ("| ");
  while (j < STATE_SHIFTS (sp))
    {
      if (STATE_SH_LIST_N_RHS (sp, j) < 100 && STATE_SH_LIST_N_RHS (sp, j) > 0)
        printf ("%2d ", STATE_SH_LIST_N_RHS (sp, j));
      else 
        printf (" 0 ");
      j++;
    }
  j=0;
  printf ("\n");
  if (TREE_STATE_TAB (p) != sp)
    {
      sp = sp - 1;
      goto BEGIN;
    }
 END:
  printf ("-------+-------+-------+-------+-------+-------+------\n");
}

/* ǥĿ    equ_tab ü 
   ȭ鿡 ѷ ݴϴ.  I  ش ǥ  RHS  ȣ̴.  ǥ 
   node    ,  ǥѴ. */
void
debug_equation (info, i, indent)
     struct hre_tree *info;
     int i;
     int indent;
{
  int z;

  for (z=0; z<indent; z++)
    putc (' ', stdout);

  if (EQU_VALUE (TREE_EQU_TAB_N (info, i)))
    {
      int args = EXP_ARGS (EQU_VALUE (TREE_EQU_TAB_N (info, i)));
      if (args == 0 )
	{
	  if (EXP_TAG (EQU_VALUE (TREE_EQU_TAB_N (info, i))) == ONE_X)
	    printf (" E%d   -> [one]\n", i);
	  else if (EXP_TAG (EQU_VALUE (TREE_EQU_TAB_N (info, i))) == ZERO_X)
	    printf (" E%d   -> [zero]\n", i);
	  else
	    {
	      char *str = 
		SYM_NAME (EXP_BODY_LEAF (EQU_VALUE (TREE_EQU_TAB_N (info, i))));
	      int length = 
		SYM_LENGTH (EXP_BODY_LEAF (EQU_VALUE (TREE_EQU_TAB_N (info, i))));

	      if (length == 1 && (str[0] & 0xff) > 0x7f)
		printf (" E%d   -> 0x%x\n", i, str[0] & 0xff);
	      else
		printf (" E%d   -> %s\n", i, str);
	    }
	}
      else if (args == 1 )
	{
	  printf (" E%d   -> E%d %s\n", i, 
		  EXP_BODY_ARG_N (EQU_VALUE (TREE_EQU_TAB_N (info, i)), 0),
		  exp_tag_name[EXP_TAG (EQU_VALUE (TREE_EQU_TAB_N (info, i)))]);
	  debug_equation (info, 
			  EXP_BODY_ARG_N (EQU_VALUE (TREE_EQU_TAB_N (info, i)), 0), 
			  indent + 4);
	}
      else if (args == 2 )
	{
	  printf (" E%d   -> E%d %s E%d\n", 
		  i, 
		  EXP_BODY_ARG_N (EQU_VALUE (TREE_EQU_TAB_N (info, i)), 0),
		  exp_tag_name[EXP_TAG (EQU_VALUE (TREE_EQU_TAB_N (info, i)))],
		  EXP_BODY_ARG_N (EQU_VALUE (TREE_EQU_TAB_N (info, i)), 1));
	  debug_equation (info, 
			  EXP_BODY_ARG_N (EQU_VALUE (TREE_EQU_TAB_N (info, i)), 0), 
			  indent + 4);
	  debug_equation (info, 
			  EXP_BODY_ARG_N (EQU_VALUE (TREE_EQU_TAB_N (info, i)), 1), 
			  indent + 4);
	}
    } 
}

void
debug_hdfa (ret, n)
     struct hdfa *ret;
     int n;
{
  int i;
  int *ip;

  ip = HDFA_TABLE_N (ret, n);
  printf ("--+----------------------------------------------------------------\n");
  printf ("  |   0   1   2   3   4   5   6   7   8   9   a   b   c   d   e   f\n");
  printf ("--+----------------------------------------------------------------\n");
  for (i=0; i<256; i++)
    {
      if (!(i % 16) && i != 0)
	{
	  printf ("\n");
	}
      if (!(i % 16))
	  printf ("%2x|", i);
      printf ("%4d", ip[i]);
    }
  printf ("\n");
}

void
debug_memory (void)
{
  printf ("޸ \n");
  printf (" Malloc : %d\n", m_stat.n_malloc);
  printf ("TMalloc : %d\n", m_stat.n_tmalloc);
  printf ("Realloc : %d\n", m_stat.n_realloc);
  printf ("   Free : %d\n", m_stat.n_free);

}
